//The Twin Blade Battle and Transport Helicopter!
//(does that sound wierd?)


datablock AudioDescription(HelicopterLooping3d)
{
   volume   = 3.0;
   isLooping= true;

   is3D     = true;
   ReferenceDistance= 5.5;
   MaxDistance= 80.0;
   type     = $SimAudioType;
};
datablock AudioProfile(HelicopterSound)
{
   filename    = "./heli.wav";
   description = HelicopterLooping3d;
   preload = true;
};
//#$#$$#$#$#$#$#$#$##$#$$#$#$#$#
datablock AudioDescription(HelicopterLooping3d2)
{
   volume   = 4.0;
   isLooping= true;

   is3D     = true;
   ReferenceDistance= 5.5;
   MaxDistance= 80.0;
   type     = $SimAudioType;
};
datablock AudioProfile(HelicopterSound2)
{
   filename    = "./heli2.wav";
   description = HelicopterLooping3d2;
   preload = true;
};
//!#@$!@#$!@#$!@#$!################################
datablock AudioDescription(HelicopterLooping3d3)
{
   volume   = 4.0;
   isLooping= true;

   is3D     = true;
   ReferenceDistance= 4.5;
   MaxDistance= 80.0;
   type     = $SimAudioType;
};
datablock AudioProfile(HelicopterDamageSound)
{
   filename    = "./alert.wav";
   description = HelicopterLooping3d3;
   preload = true;
};

datablock FlyingVehicleData(tbhVehicle)
{
// ############ SHOOT ON CLICK ###############
Readyfire=1;

ShootOnClick=1;

shootonclick_Hold=1;
shootonclick_ShootDelay=170;
shootonclick_ReShootDelay=170;
shootonclick_ProjectileCount=2;
shootonclick_RequiredSlot=0;
shootonclick_Sound=gunShot1Sound;

shootonclick_Projectile[0]=gunProjectile;
shootonclick_Position[0]="10 -1.50 -1.3";
shootonclick_Velocity[0]="180 0 0";
shootonclick_Scale[0]="1 1 1";

shootonclick_Projectile[1]=gunProjectile;
shootonclick_Position[1]="10 2.0 -1.3";
shootonclick_Velocity[1]="180 0 0";
shootonclick_Scale[1]="1 1 1";
// ############ SHOOT ON CLICK END ############

   //Tagged fields for mission editor
      category = "Vehicles";
      displayName = " ";

   //Shapebase Fields
      shapeFile   = "./chopper.dts";  //.dts File
      emap        = true;
      mass        = 200;
      drag        = 1.7;
      density     = 4;
      
      maxDamage = 180.00;
      destroyedLevel = 180.00;
      speedDamageScale = 1.04;
      collDamageThresholdVel = 20.0;
      collDamageMultiplier   = 0.02;

   //Tagged fields for mounting   
      numMountPoints = 14;
      mountThread[0] = "sit";
      mountThread[1] = "sit";
      mountThread[2] = "sit";
      mountThread[3] = "sit";
      mountThread[4] = "sit";
      mountThread[5] = "sit";
      mountThread[6] = "sit";
      mountThread[7] = "sit";
      mountThread[8] = "sit";
      mountThread[9] = "sit";
      mountThread[10] = "sit";
      mountThread[11] = "sit";
      mountThread[12] = "sit";
      mountThread[13] = "sit";

      lookUpLimit = 0.75;
		lookDownLimit = 0.35;

   //Vehicle Fields:
      jetForce          = 700;
      jetEnergyDrain    = 2;
	maxEnergy = 100;
      minJetEnergy      = 30;

      massCenter        = "0 0 -1";
      //massBox           = "1 1 1";
      bodyRestitution   = 0.5;
      bodyFriction      = 0.5;
//      softImpactSound   = slowImpactSound;
//      hardImpactSound   = fastImpactSound;

      minImpactSpeed    = 10;
      softImpactSpeed   = 10;
      hardImpactSpeed   = 30;
      minRollSpeed      = 0;
      maxSteeringAngle  = 0.785;

      maxDrag        = 40;
      minDrag        = 50;
      integration    = 4;
      collisionTol   = 0.1;
      contactTol     = 0.1;

      cameraRoll     = false;
      cameraMaxDist  = 12;      
      cameraLag      = 0.0;
      cameraDecay    = 0.0;
      cameraOffset   = 4.5;
      cameraTilt     = 0.0;

      //dustEmitter       = ; //ParticleEmitterData
      triggerDustHeight = 3.0;
      dustHeight        = 1.0;

      numDmgEmitterAreas   = 1;
      
      damageEmitter[0] = vehicleBurnEmitter;
      damageEmitterOffset[0] = "0.0 0.0 0.0 ";
      damageLevelTolerance[0] = 0.99;

      damageEmitter[1] = vehicleBurnEmitter;
      damageEmitterOffset[1] = "0.0 0.0 0.0 ";
      damageLevelTolerance[1] = 1.0;

      //splashEmitter[0]        = ; //ParticleEmitterData

      splashFreqMod     = 300.0;
      splashVelEpsilon  = 0.50;

      splash = vehicleSplash;
      splashVelocity = 4.0;
      splashAngle = 67.0;
      splashFreqMod = 300.0;
      splashVelEpsilon = 0.60;
      bubbleEmitTime = 1.4;
      splashEmitter[0] = vehicleFoamDropletsEmitter;
      splashEmitter[1] = vehicleFoamEmitter;
      splashEmitter[2] = vehicleBubbleEmitter;
      mediumSplashSoundVelocity = 10.0;   
      hardSplashSoundVelocity = 20.0;   
      exitSplashSoundVelocity = 5.0;

      exitSplashSoundVelocity    = 2.0;
      softSplashSoundVelocity    = 1.0;
      mediumSplashSoundVelocity  = 2.0;
      hardSplashSoundVelocity    = 3.0;
      //exitingWater               = ;   //AudioProfile
      //impactWaterEasy            = ;   //AudioProfile
      //impactWaterMedium          = ;   //AudioProfile
      //impactWaterHard            = ;   //AudioProfile
      //waterWakeSound             = ;   //AudioProfile

      collDamageThresholdVel  = 20;
      collDamageMultiplier    = 0.05;

   //For Wrench Gui
      uiName   = "Twin Blade Helicopter";
      rideAble = true;
      paintable = true;
		
   //Flying vehicle fields
      //jetSound = ;      //AudioProfile
      //engineSound = ;   //AudioProfile


      maneuveringForce        = 3000;
      horizontalSurfaceForce  = 20;
      verticalSurfaceForce    = 20;
      autoInputDamping        = 0.55;
      steeringForce           = 1500;
      steeringRollForce       = 50;// 200
      rollForce               = 10;
      autoAngularForce        = 1400;
      rotationalDrag          = 20;
      autoLinearForce         = 100;
      maxAutoSpeed            = 10;
      hoverHeight             = 2.9;
      createHoverHeight       = 2.0;

      //forwardJetEmitter    = ; //ParticleEmitterData
      //backwardJetEmitter   = ; //ParticleEmitterData
      //downJetEmitter       = ; //ParticleEmitterData
      //trailEmitter         = ; //ParticleEmitterData

      minTrailSpeed        = 1;
      vertThrustMultiple   = 1.0;
   
   //Tagged fields for damage
      initialExplosionProjectile = vehicleExplosionProjectile;
      initialExplosionOffset = 0;         //offset only uses a z value for now

      burnTime = 3500;

      finalExplosionProjectile = vehicleFinalExplosionProjectile;
      finalExplosionOffset = 0.5;          //offset only uses a z value for now

      minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
      runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
      runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

minJetEngineSpeed = 10;//20
};

//##########smoke datablocks##########
datablock ParticleData(tbhEngineSmokeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 150;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 2.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.6 0.6 0.6 0.5";
	colors[1]     = "1.0 1.0 1.0 0.3";// .9 .9 .9 .3
	sizes[0]      = 0.6;
	sizes[1]      = 0.6;
	times[0]		= 1.0;
	times[1]		= 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(tbhEngineSmokeEmitter)
{
   ejectionPeriodMS = 6;
   periodVarianceMS = 5;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tbhEngineSmokeParticle";
   
   uiName = "Twin Blade Helicopter Engine Smoke Emitter";
};

//##########Creating the smoke!##########
datablock ShapeBaseImageData(heliSmokeImage)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 15;
   rotation = "1 0 0 180";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 10000;
	stateEmitter[1]					= tbhEngineSmokeEmitter;
	stateEmitterTime[1]				= 10000;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};


function tbhVehicle::onadd(%this,%obj)
{
	   %obj.playThread(0,"spin");
	     %obj.PlayAudio(0,HelicopterSound2);
	       %obj.PlayAudio(1,HelicopterSound);
	%obj.mountImage(heliSmokeImage,0);
}


//##########Creating the damage smoke##########
datablock ParticleData(tbhEngineDamageParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 2900;
	lifetimeVarianceMS   = 340;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 2.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.000000 1.000000 1.000000 0.100000";
	colors[1]     = "1.000000 0.496063 0.000000 0.100000";
   	colors[2]     = "1.000000 1.000000 1.000000 0.100000";
   	colors[3]     = "1.000000 1.000000 1.000000 0.100000";

	sizes[0]      = 2.0946103;
	sizes[1]      = 2.897272;
 	sizes[2]      = 4;
 	sizes[3]      = 4;

   	times[0] = 0;
   	times[1] = 1;
   	times[2] = 2;
  	times[3] = 2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(tbhEngineDamageEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 3;
   ejectionVelocity = 0.2;
   velocityVariance = 0.1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tbhEngineDamageParticle";
   
   uiName = "Twin Blade Helicopter Damage Emitter";
};

datablock ShapeBaseImageData(heliDamageImage)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 17;
   rotation = "1.1 0 0 179";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 10000;
	stateEmitter[1]					= tbhEngineDamageEmitter;
	stateEmitterTime[1]				= 10000;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};

function tbhVehicle::onDamage(%this,%obj)
{
	%damLvl = %obj.getDamageLevel();// sets variable "%damLvl"
	%pos = %obj.getPosition();//same

	if(%damLvl >= 120) // checks damage level (30 health remaining?)
	{
		%obj.mountImage(heliDamageImage,0);// fire!
	       %obj.PlayAudio(2,HelicopterDamageSound);
	}

}

   function tbhVehicle::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e)
   {
      if(%col.dataBlock.className $= "Glass" && !%col.indestructable)
      {
         %col.explode();// no moar bedroom glass!
      }
      Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e);
   }

// spacebar!
   function tbhVehicle::onTrigger(%this,%obj,%client)
   {
	
	%obj.setvelocity("0 0 8");

   }